/**
 * @properties={typeid:35,uuid:"55E158A1-927F-43B9-9E75-6FD695E1C559"}
 */
var html = "";

/**
 * @properties={typeid:35,uuid:"C4A86800-AF0B-472C-8045-678EAC56587F",variableType:-4}
 */
var planesMap = null;

/**
 * @properties={typeid:24,uuid:"FE261269-5731-4991-832D-FF496A62F88C"}
 */
function jsInitCalendar() {

	var content = '\
\
		scheduler.locale.labels.timeline_tab = "Timeline"; \
		scheduler.locale.labels.section_custom="Section"; \
		scheduler.config.details_on_dblclick=true; \
		scheduler.config.details_on_create=true; \
		scheduler.config.xml_date="%Y-%m-%d %H:%i"; \
\
		scheduler.config.default_date = "%j %M %Y (#%W)"; \
\
		var sections=[ \
		';
	// Add planes
	planesMap = new java.util.HashMap();

	var size = 1;
	for (var i = 1; i <= size; i++) {

		content += '{key:' + 1 + ', label:"' + 'Section' + '"}';
		planesMap.put(1, i);

		if (i < size) {
			content += ', \
				';
		} else {
			content += '\
				';
		}
	}
	content += ']; \
\
		scheduler.createTimelineView({ \
			name:	"timeline", \
			x_unit:	"day", \
			x_date:	"%D", \
			x_step:	  1, \
			x_size:   7, \
			x_start:  0, \
			x_length: 7, \
			y_unit:	sections, \
			y_property:	"section_id", \
			render:"bar" \
		}); \
\
		scheduler.init("scheduler_here", new Date(2011,05,03), "timeline"); \
		';

	content += jsCalendarEvents();

	return content; 
}

/**
 * @properties={typeid:24,uuid:"DA4208BE-BE29-4F61-A535-5543F02B81DC"}
 */
function jsCalendarEvents() {

	var content = 'scheduler.clearAll();\
		scheduler.parse([ \
		';

	var size = 50;
	for (var i = 1; i <= size; i++) {

		var date = new Date();
		date.setDate(date.getDate() + i);
		
		var date2 = new Date();
		date2.setDate(date2.getDate() + i);
		date2.setHours(date2.getHours() + 2);

		content += '{ id:"' + i + '", ' 
				+ 'start_date:"' + utils.dateFormat(date, "yyyy-MM-dd HH:mm") + '", ' 
				+ 'end_date:"' + utils.dateFormat(date2, "yyyy-MM-dd HH:mm")  + '", '
				+ 'text:"' + 'Hello !!!' + '", '
				+ 'section_id:' + 1 + '}';

		if (i < size) {
			content += ', \
				';
		} else {
			content += '\
				';
		}
	}

	content += '\
		],"json"); \
		';

	return content;
}

/**
 * @properties={typeid:24,uuid:"DF2CB145-251A-45C1-B10A-AD031229E47E"}
 */
function htmlHeader() {
	
	var server = 'localhost:8080';
	
	return '\
<html> \
<head> \
<meta http-equiv="Content-type" content="text/html; charset=utf-8"> \
\
<script src="http://' + server + '/scheduler/dhtmlxscheduler.js" type="text/javascript" charset="utf-8"></script> \
<script src="http://' + server + '/scheduler/ext/dhtmlxscheduler_timeline.js" type="text/javascript" charset="utf-8"></script> \
<script src="http://' + server + '/scheduler/ext/dhtmlxscheduler_minical.js" type="text/javascript" charset="utf-8"></script> \
\
<link rel="stylesheet" type="text/css" href="http://' + server + '/scheduler/dhtmlxscheduler.css"> \
<link rel="stylesheet" href="http://' + server + '/scheduler/ext/dhtmlxscheduler_ext.css" type="text/css" media="screen" title="no title" charset="utf-8"> \
<link rel="stylesheet" href="http://' + server + '/scheduler/week.css" type="text/css" media="screen"> \
\
<script type="text/javascript" charset="utf-8"> \
	function callFromClient(myID) { \
		' + plugins.WebClientUtils.addCallback(editReservation, ['myID']) + ' \
			alert("Server will be called now with param: " + myID); \
	} \
	scheduler.showLightbox = function(reservation_id) { \
		alert("123");\
		' + plugins.WebClientUtils.addCallback(editReservation, ['reservation_id']) + ' \
	} \
</script> \
\
</head> \
';

}

/**
 * @properties={typeid:24,uuid:"EA9CDBE4-D39F-456B-BB32-C3B6CDFA696A"}
 */
function htmlBody(firstShow) {
	var body = '';

/*	body += '\
	<script type="text/javascript" charset="utf-8"> \
		scheduler.showLightbox = function(reservation_id) { \
			alert("123");\
			' + plugins.WebClientUtils.addCallback(editReservation, ['reservation_id']) + ' \
		} \
		\
	</script>';*/

	body += '<body' + (firstShow ? '' : ' onload="initJSCalendar();"') + '> \
<button type="button" onClick="callFromClient(13)">Click me to call the server!</button> \
<div id="scheduler_here" class="dhx_cal_container" style="width:100%; height:100%;"> \
<div class="dhx_cal_navline"> \
<div class="dhx_cal_prev_button">&nbsp;</div> \
<div class="dhx_cal_next_button">&nbsp;</div> \
<div class="dhx_cal_today_button"></div> \
<div class="dhx_cal_date"></div> \
<div class="dhx_cal_tab" name="day_tab" style="right:204px;"></div> \
<div class="dhx_cal_tab" name="week_tab" style="right:140px;"></div> \
<div class="dhx_cal_tab" name="timeline_tab" style="right:280px;"></div> \
<div class="dhx_cal_tab" name="month_tab" style="right:76px;"></div> \
</div> \
<div class="dhx_cal_header"> \
</div> \
<div class="dhx_cal_data"> \
</div> \
</div> \
</body> \
</html> \
';

	return body;
}

/**
 * @properties={typeid:24,uuid:"9574764F-7D7F-4D36-A33A-D7AF0C2B9D2F"}
 */
function refreshCalendar(type) {

	application.output("generate HTML start !!!");	

	if (type == 1) {
		plugins.WebClientUtils.executeClientSideJS(jsInitCalendar());

	} else {

		var jsCode = '\
			';

		if (type == undefined) {
			jsCode += 'scheduler.init("scheduler_here", scheduler.getState().date, scheduler.getState().mode); \
				';
		}

		jsCode += jsCalendarEvents();

		plugins.WebClientUtils.executeClientSideJS(jsCode);
	}

	application.output("generate HTML ends !!!");	
}

/**
 * Callback method when form is (re)loaded.
 *
 * @param {JSEvent} event the event that triggered the action
 *
 * @properties={typeid:24,uuid:"E72FD4A5-5E62-447B-BA88-B7EE9205F7B8"}
 */
function onLoad(event) {
	html = htmlHeader() + htmlBody(true);
}

/**
 * Callback method for when form is shown.
 *
 * @param {Boolean} firstShow form is shown first time after load
 * @param {JSEvent} event the event that triggered the action
 *
 * @properties={typeid:24,uuid:"DC25980C-F0AA-483A-AEEC-05D5EDCDB0F1"}
 */
function onShow(firstShow, event) {
	if (firstShow) {
		refreshCalendar(1);
	} else {

		refreshCalendar();
	}
}

/**
 * @properties={typeid:24,uuid:"CCD31E76-D3E6-45B6-8217-27DDAD27B1E9"}
 */
function onTestAction(event) {
	refreshCalendar();
}

/**
 * @properties={typeid:24,uuid:"3074E614-412F-4F3C-9B9A-D4C8D6C7A8FC"}
 */
function editReservation() {
	application.output("editReservation: " + arguments[0]);
	forms.main_form_2.onAction2();
}
